Skip to contentSkip to navigationSkip to topbar

Memory API (v1) - Store endpoints


(information)

Legal information

Conversation Memory, including the APIs, may use artificial intelligence or machine learning technologies and is subject to the terms of the Predictive and Generative AI/ML Features Addendum(link takes you to an external page). For more details on AI usage and data, see the AI Nutrition Facts.

Conversation Memory is not a HIPAA Eligible Service or PCI compliant and should not be enabled in workflows that are subject to HIPAA or PCI.

Conversation Memory is not intended for use with sensitive information about individuals. Twilio does not control what information comes from conversation channels and relies on you to ensure the data in customer profiles aligns with our acceptable use policy. Twilio does have limited guardrails in the form of a prompt exclusion that is designed to provide a minimal screening against inclusion of GDPR special category data(link takes you to an external page). As a reminder our profile technology uses generative artificial intelligence. Because generative artificial intelligence can make mistakes, review all outputs to ensure that the profile is correct.

Overview

overview page anchor

Tag description

Endpoints


Create a Memory Store

create-store page anchor

POST/v1/ControlPlane/Stores

Base url: https://memory.twilio.com (base url)

Create a new Memory Store for the Twilio account. Accounts can have multiple memory stores, up to a maximum limit of 15. Each memory store will automatically provision other dependent resources as needed, including Conversational Intelligence capabilities.

Request

create-store-request page anchor

Request body

create-store-request-body page anchor
Encoding type:application/json
Schema
Property nameTypeRequiredPIIDescriptionChild properties
displayNamestring
required
Not PII

Provides a unique and addressable name to be assigned to this Store. This name is assigned by the developer and can be used in addition to the ID. It is intended to be human-readable and unique within the account.

Example: sandboxPattern: ^[a-zA-Z0-9-]+$

descriptionstring

Optional

A human readable description of this resource, up to 128 characters.

Example: A testing ground for development, training, and experimentation without affecting live user dataMin length: 1Max length: 128
202400404429500503

Store creation accepted for async processing. Inspect the status URL for progress.

Schema
Property nameTypeRequiredPIIDescriptionChild properties
messagestring

Optional

Example: Memory Store creation accepted for processing.Max length: 512

statusUrlstring

Optional

URI to check operation status.

Max length: 512
Create a Memory StoreLink to code sample: Create a Memory Store
1
// Download the helper library from https://www.twilio.com/docs/node/install
2
const twilio = require("twilio"); // Or, for ESM: import twilio from "twilio";
3
4
// Find your Account SID and Auth Token at twilio.com/console
5
// and set the environment variables. See http://twil.io/secure
6
const accountSid = process.env.TWILIO_ACCOUNT_SID;
7
const authToken = process.env.TWILIO_AUTH_TOKEN;
8
const client = twilio(accountSid, authToken);
9
10
async function createStore() {
11
const store = await client.memory.v1.stores.create({
12
displayName: "sandbox",
13
});
14
15
console.log(store.message);
16
}
17
18
createStore();

Response

Note about this response
1
{
2
"message": "message",
3
"statusUrl": "statusUrl"
4
}

List Memory Stores

list-stores page anchor

GET/v1/ControlPlane/Stores

Base url: https://memory.twilio.com (base url)

Get a list of memory stores for the Twilio account.

Property nameTypeRequiredPIIDescription
pageSizeinteger

Optional

The maximum number of items to return per page, maximum of 100.

Default: 50Minimum: 1Maximum: 100

pageTokenstring

Optional

The token for the page of results to retrieve.

Max length: 500

orderByenum<string>

Optional

Either 'ASC' or 'DESC' to sort results ascending or descending respectively.

Default: DESCPossible values:
ASCDESC
200400404429500503

Memory stores retrieved successfully

Schema
Property nameTypeRequiredPIIDescriptionChild properties
storesarray[string]

Optional

List of Memory Store IDs associated with the Twilio account.

Example: ["mem_store_0123456789abcdefghijklmnop","mem_store_1123456789abcdefghijklmnop","mem_store_2123456789abcdefghijklmnop","mem_store_3123456789abcdefghijklmnop"]Max items: 100

metaobject

Optional

1
// Download the helper library from https://www.twilio.com/docs/node/install
2
const twilio = require("twilio"); // Or, for ESM: import twilio from "twilio";
3
4
// Find your Account SID and Auth Token at twilio.com/console
5
// and set the environment variables. See http://twil.io/secure
6
const accountSid = process.env.TWILIO_ACCOUNT_SID;
7
const authToken = process.env.TWILIO_AUTH_TOKEN;
8
const client = twilio(accountSid, authToken);
9
10
async function listStores() {
11
const stores = await client.memory.v1.stores.list({
12
orderBy: "DESC",
13
limit: 20,
14
});
15
16
stores.forEach((s) => console.log(s));
17
}
18
19
listStores();

Response

Note about this response
1
{
2
"meta": {
3
"key": "key",
4
"pageSize": 50,
5
"nextToken": "nextToken",
6
"previousToken": "previousToken"
7
},
8
"stores": [
9
"mem_store_01111111111111111111111111"
10
]
11
}

Retrieve a Memory Store

fetch-store page anchor

GET/v1/ControlPlane/Stores/{storeId}

Base url: https://memory.twilio.com (base url)

Retrieve the details of a specific Memory Store by its unique ID.

Property nameTypeRequiredPIIDescription
storeIdstring
required

A unique Memory Store ID using Twilio Type ID (TTID) format

Example: mem_store_00000000000000000000000000Pattern: ^mem_(store|service)_[0-7][0-9a-z]{25}$
200400404429500503

Memory Store details retrieved successfully

Schema
Property nameTypeRequiredPIIDescriptionChild properties
displayNamestring

Optional

Provides a unique and addressable name to be assigned to this Store. This name is assigned by the developer and can be used in addition to the ID. It is intended to be human-readable and unique within the account.

Example: sandboxPattern: ^[a-zA-Z0-9-]+$

descriptionstring

Optional

A human readable description of this resource, up to 128 characters.

Example: A testing ground for development, training, and experimentation without affecting live user dataMin length: 1Max length: 128

idstring

Optional

The unique identifier for the Memory Store

Example: mem_store_00000000000000000000000000Pattern: ^mem_(store|service)_[0-7][0-9a-z]{25}$

statusenum<string>

Optional

The current status of the Memory Store. A store begins in the QUEUED state as it is scheduled for processing. It then moves to PROVISIONING at the beginning of processing. It transitions to ACTIVE once all dependent resources are provisioned, including Conversational Intelligence capabilities. If there is an issue provisioning resources, the store will move to the FAILED state.

Example: ACTIVEPossible values:
QUEUEDPROVISIONINGACTIVEFAILED

intelligenceServiceIdstring

Optional

The ID of the associated intelligence service that was provisioned for memory extraction.

Example: intelligence_service_00000000000000000000000000Max length: 64

versioninteger

Optional

The current version number of the Memory Store. Incremented on each successful update.

Example: 3Minimum: 1
1
// Download the helper library from https://www.twilio.com/docs/node/install
2
const twilio = require("twilio"); // Or, for ESM: import twilio from "twilio";
3
4
// Find your Account SID and Auth Token at twilio.com/console
5
// and set the environment variables. See http://twil.io/secure
6
const accountSid = process.env.TWILIO_ACCOUNT_SID;
7
const authToken = process.env.TWILIO_AUTH_TOKEN;
8
const client = twilio(accountSid, authToken);
9
10
async function fetchStore() {
11
const store = await client.memory.v1
12
.stores("mem_store_00000000000000000000000000")
13
.fetch();
14
15
console.log(store.displayName);
16
}
17
18
fetchStore();

Response

Note about this response
1
{
2
"description": "description",
3
"displayName": "sandbox",
4
"id": "mem_store_00000000000000000000000000",
5
"intelligenceServiceId": "intelligenceServiceId",
6
"status": "ACTIVE",
7
"version": 3
8
}

Update a Memory Store

patch-store page anchor

PATCH/v1/ControlPlane/Stores/{storeId}

Base url: https://memory.twilio.com (base url)

Partially update a Memory Store. Only the fields provided in the request body will be updated.

Property nameTypeRequiredPIIDescription
if-Matchstring

Optional

Allows for optimistic concurrency control by making the request conditional. Server will only act if the resource's current Entity Tag (ETag) matches the one provided, preventing accidental overwrites.

Example: "eyJpZCI6ImFuX2lkIiwidiI6MX0"Max length: 100
Property nameTypeRequiredPIIDescription
storeIdstring
required

A unique Memory Store ID using Twilio Type ID (TTID) format

Example: mem_store_00000000000000000000000000Pattern: ^mem_(store|service)_[0-7][0-9a-z]{25}$
Encoding type:application/json
Schema
Property nameTypeRequiredPIIDescriptionChild properties
displayNamestring

Optional

Provides a unique and addressable name to be assigned to this Store. This name is assigned by the developer and can be used in addition to the ID. It is intended to be human-readable and unique within the account.

Example: sandbox-updatedPattern: ^[a-zA-Z0-9-]+$

descriptionstring

Optional

A human readable description of this resource, up to 128 characters.

Example: Updated service for development and testingMin length: 1Max length: 128
202400404429500503

Memory Store update request accepted.

Schema
Property nameTypeRequiredPIIDescriptionChild properties
messagestring

Optional

Example: Memory Store update request accepted for processing.Max length: 512

statusUrlstring

Optional

URI to check operation status.

Max length: 512
1
// Download the helper library from https://www.twilio.com/docs/node/install
2
const twilio = require("twilio"); // Or, for ESM: import twilio from "twilio";
3
4
// Find your Account SID and Auth Token at twilio.com/console
5
// and set the environment variables. See http://twil.io/secure
6
const accountSid = process.env.TWILIO_ACCOUNT_SID;
7
const authToken = process.env.TWILIO_AUTH_TOKEN;
8
const client = twilio(accountSid, authToken);
9
10
async function patchStore() {
11
const store = await client.memory.v1
12
.stores("mem_store_00000000000000000000000000")
13
.patch({
14
displayName: "sandbox-updated",
15
});
16
17
console.log(store.message);
18
}
19
20
patchStore();

Response

Note about this response
1
{
2
"message": "message",
3
"statusUrl": "statusUrl"
4
}